// test_event.cpp
// Glenn G. Chappell
// 8 Oct 2013
//
// For CS 202 Fall 2013
// Test program for class Event

#include "event.h"  // For class Event
#include "event.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <string>
using std::string;
#include <sstream>
using std::ostringstream;


bool allGood = true;  // true if all tests pass so far


// testEvent_basic
// Test for class Event: construction & print
// Prints results of tests, sets global allGood to false if any fail
void testEvent_basic()
{
    cout << endl;
    cout << "Test: Construction & stream output" << endl;

    {
    const string n = "";
    Event e(n);
    ostringstream os;
    os << e;
    string s = os.str();
    string ans = " ( 0:00:00)";
    cout << "String version of event (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    const string n = "Opening";
    Event e(n);
    ostringstream os;
    os << e;
    string s = os.str();
    string ans = "Opening ( 0:00:00)";
    cout << "String version of event (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    const string n = "Opening";
    Event e(n, 1, 2, 3);
    ostringstream os;
    os << e;
    string s = os.str();
    string ans = "Opening ( 1:02:03)";
    cout << "String version of event (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    const string n = "Closing";
    Event e(n, 10, 11, 12);
    ostringstream os;
    os << e;
    string s = os.str();
    string ans = "Closing (10:11:12)";
    cout << "String version of event (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    const string n = "X";
    Event e(n, 5, 5, 5);
    ostringstream os;
    os << e << e;
    string s = os.str();
    string ans = "X ( 5:05:05)X ( 5:05:05)";
    cout << "String version of 2 events\n  (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }
}


// main program
// Runs tests for class Event, prints results
int main()
{
    testEvent_basic();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

